// tested  HC-SR04 > DFRobot Mini MP3-Player

/* required MP3-Soundfiles 
0010.mp3; 0015.mp3; 0020.mp3; 0025.mp3; 0030.mp3; 0035.mp3;
0040.mp3; 0045.mp3; 0050.mp3; 0055.mp3; 0060.mp3; 0065.mp3;
0070.mp3; 0075.mp3; 0080.mp3; 0085.mp3; 0090.mp3; 0095.mp3;
0100.mp3; 
0105.mp3 (Underloadmessage); 
0110.mp3 (Overloadmessage);
0115.mp3 (Startmessage) 
0200.mp3 (Minimaldistanz Einzelmessage) 
0255.mp3 (Leerfile) */ 

#include <string.h>
#include <ctype.h>
#include <DFPlayer_Mini_Mp3.h>
#include <avr/pgmspace.h>
#include <SoftwareSerial.h>

#define trigger 11  // Arduino Pin for HC-SR04 Trig
#define echo 10     // Arduino Pin for HC-SR04 Echo

SoftwareSerial mySerial(4, 5); // RX, TX  

int ledPin = 13;   
int call;
int buusyPin = 2;              // sound player busy
int bsy = 0;
int z = 0;
byte n = 1;
byte mrk = 1;

///////////////////////////////////////////////////////
void setup () {
	Serial.begin (9600);
	Serial.println("Start");
        mySerial.begin (9600);

  pinMode(14, INPUT_PULLUP); // #14 = A0 as input
  pinMode(15, INPUT_PULLUP); // #15 = A1 as input
  pinMode(ledPin, OUTPUT);
  digitalWrite(ledPin, LOW);  
  pinMode(trigger, OUTPUT);
  pinMode(echo, INPUT);

        mp3_set_serial (&mySerial);	//set softwareSerial for DFPlayer-mini mp3 module 
        delay(100);
        call = 115;                      
        speak();                    // speak startmessage
        wait_end();  
        delay(1000);
       }

       long duration=0;
       long distance=0;

///////////////////////////////////////////////////////
void loop () {        

  digitalWrite(trigger, LOW);  
  delayMicroseconds(2); 
 
  digitalWrite(trigger, HIGH);  
  delayMicroseconds(10);
  
  digitalWrite(trigger, LOW);
  duration = pulseIn(echo, HIGH); // measure echo time 
  duration = (duration/2); 
  distance = duration / 29.1;
  
  Serial.print("Distanz : ");  
  Serial.print(distance);
  Serial.println("cm");

  int sensorVal1 = digitalRead(14);
  int sensorVal2 = digitalRead(15);

//////////////////////////////////////////////////////////////
// run if #A0 and #A1 = "HIGH" 
  if (sensorVal1&&sensorVal2 == HIGH) 
{
if (distance>=102)              { call = 110; }
else
if (distance>=97&&distance<102) { call = 100; }
else
if (distance>=92&&distance<97)  { call = 95;  }
else
if (distance>=87&&distance<92)  { call = 90;  } 
else
if (distance>=82&&distance<87)  { call = 85;  }
else
if (distance>=77&&distance<82)  { call = 80;  } 
else
if (distance>=72&&distance<77)  { call = 75;  }
else
if (distance>=67&&distance<72)  { call = 70;  }
else
if (distance>=62&&distance<67)  { call = 65;  }
else
if (distance>=57&&distance<62)  { call = 60;  }
else
if (distance>=52&&distance<57)  { call = 55;  }  
else
if (distance>=47&&distance<52)  { call = 50;  }
else
if (distance>=42&&distance<47)  { call = 45;  }
else
if (distance>=37&&distance<42)  { call = 40;  }
else
if (distance>=32&&distance<37)  { call = 35;  }
else
if (distance>=27&&distance<32)  { call = 30;  }
else
if (distance>=22&&distance<27)  { call = 25;  }
else
if (distance>=17&&distance<22)  { call = 20;  }
else
if (distance>=12&&distance<17)  { call = 15;  }
else
if (distance>=7&&distance<12)   { call = 10;  }
else
if (distance<7)                 { call = 105; }

   speak();
   wait_end();
   Serial.println("");
   digitalWrite(ledPin, HIGH);  
   delay(1000);
   digitalWrite(ledPin, LOW); 
   delay(1000);
  }

//////////////////////////////////////////////////////////////
// run if #A0 = "LOW" 
  if (sensorVal1 == LOW) 
{
if (distance>=102)              { call = 255; }
else
if (distance>=97&&distance<102) { call = 100; }
else
if (distance>=92&&distance<97)  { call = 95;  }
else
if (distance>=87&&distance<92)  { call = 90;  } 
else
if (distance>=82&&distance<87)  { call = 85;  }
else
if (distance>=77&&distance<82)  { call = 80;  } 
else
if (distance>=72&&distance<77)  { call = 75;  }
else
if (distance>=67&&distance<72)  { call = 70;  }
else
if (distance>=62&&distance<67)  { call = 65;  }
else
if (distance>=57&&distance<62)  { call = 60;  }
else
if (distance>=52&&distance<57)  { call = 55;  }  
else
if (distance>=47&&distance<52)  { call = 50;  }
else
if (distance>=42&&distance<47)  { call = 45;  }
else
if (distance>=37&&distance<42)  { call = 40;  }
else
if (distance>=32&&distance<37)  { call = 35;  }
else
if (distance>=27&&distance<32)  { call = 30;  }
else
if (distance>=22&&distance<27)  { call = 25;  }
else
if (distance>=17&&distance<22)  { call = 20;  }
else
if (distance>=12&&distance<17)  { call = 15;  }
else
if (distance>=7&&distance<12)   { call = 10;  }
else
if (distance<7)                 { call = 105; }

   speak();
   wait_end();
   Serial.println("");
   digitalWrite(ledPin, HIGH);  
   delay(1000);
   digitalWrite(ledPin, LOW); 
  }

/////////////////////////////////////////////////////////////
// run if #A1 = "LOW" 
   if (sensorVal2 == LOW) 
{
 if (distance<50)  
 {
    n++;
    delay(1000); 
    Serial.print(n);
 if (n==3&&mrk==1) 
  { call = 200; 
    speak(); 
    wait_end(); 
    mrk=0;  
    n=1; 
    Serial.println(" "); }  
  }
 else if (distance>100) 
  { mrk=1; 
    digitalWrite(ledPin, HIGH);  
    delay(200);
    digitalWrite(ledPin, LOW); 
    delay(200); 
    n=1; }
 }
}

//////////////////////////////////////////////////////////
void wait_end() 
{   
  int bsyflag = 0;
  for ( z = 0; z <= 10000; z++) {
    bsy = digitalRead(buusyPin);
    delay(50);
    if (bsyflag == 1 && bsy == 1) {
      break;
    }
    if (bsy == 0) {
      bsyflag = 1;
    }
  }  
}

////////////////////////////////////////////////////////////
void speak() 
  {
  mp3_play (call);
  Serial.print("MP3-Call: ");
  Serial.println(call);
  } 

 
 
